// Aufruf Lokal | Vienna 08.08.2008
//
// Flugzeug erstellen. Anflug aufs Ziel. Abwurf der Bomben.
// 
// Westseite wird automaitsch mit A10 angeflogen, Ostseite mit Su34.
//
// Parameter: [[<Zielposition>],<Anzahl Einschlge>,<MunitionsNummer(1-3)>,<Streuung>]
//
// Verwendet Skripte "AirMarker.sqf" und Explosionen.sqf

// lokale Variable
	private ["_p","_z","_a","_s","_t","_xy1","_xy2","_h","_d","_e1","_e2","_e3","_f","_w","_wp"];

//globale Variable beim ersten Aufruf fr Bestimmung des Anflugorts initialisieren.
	if (isNil "ViennasAnflugRichtung") then {ViennasAnflugRichtung = floor(random 4)};


// 1) Flugzeug erstellen ///////////////////////////////////
////////////////////////////////////////////////////////////

// _p: Position des Ziels
  _p = _this select 0;
// _z: Logik-Objekt auf Zielposition
	_z = "Logic" createVehicleLocal _p;
// Seehhe des Ziels
	_a = getPosASL _z select 2;
// _s: Seite des Spielers
	_s = playerSide;
// _t: 5 Minuten Notausstieg aus Skript
	_t = time + 300;

// _w: Anflughhe
	_w = 400;
// _xy1: Anflugposition von N, E, S oder W
	ViennasAnflugRichtung = ViennasAnflugRichtung + 1; if (ViennasAnflugRichtung > 3) then {ViennasAnflugRichtung = 0};
	_xy1 = [[_p select 0,(_p select 1)+3000],[(_p select 0)+4000,_p select 1],[_p select 0,(_p select 1)-5000],[(_p select 0)-4000,_p select 1]];
// _xy2: Umkehrposition nach Zielverfehlung S, W, N oder E
	_xy2 = [[_p select 0,(_p select 1)-2500,400+_a],[(_p select 0)-2500,_p select 1,400+_a],[_p select 0,(_p select 1)+2500,_w+_a],[(_p select 0)+2500,_p select 1,400+_a]];
			
// _h: Heli Objekt
	_h = createVehicle [if(_s == WEST)then{"A10"}else{"Su34"},_xy1 select ViennasAnflugRichtung,[],500,"FLY"];
	_h setPos [getPos _h select 0,getPos _h select 1,_w+_a];

// _d: Pilot Objekt
	_d = createGroup _s createUnit [if(_s == WEST)then{"SoldierWPilot"}else{"SoldierEPilot"}, [0,0], [], 0, "FORM"];
	_d setBehaviour "careless";
	_d allowFleeing 0;
	_d setCombatMode "BLUE";
	_d moveInDriver _h;
	//---> Nur fr Testzwecke: player moveInGunner _h; // Spieler als Schtze in den Flieger (nur bei SU34 mglich).


// 2) Flugzeug fliegt zum Ziel /////////////////////////////
////////////////////////////////////////////////////////////

player groupChat "Kampfflieger im Anflug!";

// Skript starten welches Ziel- und Flugzeugmarker steuert 
	[_h,_z] execVM "AirHQ\AirMarker.sqf";

// _e1,_e2,_e3: Steuervariable 
	_e1 = true;  //Warten bis Pilot in Abwurfentfernung
	_e2 = 0;     //Steuert Entfernungsabfragen
	_e3 = 10000; //Wert zeigt an, ob Flugzeug vor dem Ziel

// Hauptschleife
	// _wp: fr Wegpunkthandhabung
	_wp = group _d addWaypoint [_p,0]; group _d setCurrentWaypoint [group _d, 1];
	_h flyinHeight (_w+_a);
	_h setspeedMode "NORMAL";
	while {_e1 AND alive _h AND time < _t} do 
		{
			// _f: Entfernung zum Ziel
			_f = _h distance _z;
			hint format["ANFLUGINFORMATION (siehe Map)\n\nEntfernung zum Ziel: %1 m\nGeschwindigkeit: %2 km/h\nFlugrichtung: %3 Grad\nBodenabstand: %4 m",floor(_h distance _z),floor(speed _h),floor(getDir _h),floor(getPos _h select 2)];
			//---> Nur fr Testzwecke: hint format["Bomber Entfernung zum Ziel: %1\nFlugrichtung: %2 Grad\nBodenabstand beim Flug: %3\n\nZielort-Seehoehe: %4\nFlieger-Seehoehe: %5\n\nAbstand Ziel zu Flugzeug\nX: %6    Y: %7\n\nVerbleibende Zeit: %7 sek",floor(_h distance _z),floor(getDir _h),floor(getPos _h select 2),floor _a, floor(getPosASL _h select 2),floor abs((getpos _z select 0)-(getpos _h select 0)),floor abs((getpos _z select 1)-(getpos _h select 1)),floor (_t-time)];
			//Wenn Bombenabwurf nicht mglich war, Anflug von der Umkehrposition.
			if (_f > 2500 and _e2==1) then
				{
					_h flyinHeight _w+_a;
					_h setspeedMode "NORMAL";
					_h setPos (_xy2 select ViennasAnflugRichtung);
					ViennasAnflugRichtung = ViennasAnflugRichtung + 1; if (ViennasAnflugRichtung > 3) then {ViennasAnflugRichtung = 0}; //Falls diese fehlschlgt, fr nchste Umkehrposition
					_e2=0;
					_e3 = 10000;
					_w = _w - 70; //Einsatzhhe verringern
					_wp = group _d addWaypoint [_p,0]; group _d setCurrentWaypoint [group _d, 1];
					player groupChat "Bombenabwurf fehlgeschlagen! Nochmaliger Anflug!"
				};
			//Sturzflug einleiten?
			if (_f < 2000 and _e2==0) then {_e2=1; _h flyinHeight(if(_a<80)then{80}else{_a});_h setspeedMode "LIMITED"};
			//Bombenabwurf einleiten wenn Flugzeug nher 400m und vor dem Ziel? (Distanz Ziel zu Flieger 400m, allerdings nicht reine berflughhe!)
			if (_f <  400 AND _f < _e3 AND ( abs((getpos _z select 0)-(getpos _h select 0)) > 300 OR abs((getpos _z select 1)-(getpos _h select 1)) > 300 ) ) then {_e1 = false};
			//Alte Zielentfernung sichern bzw. Pilot Wegpunkte lschen
			if (_e3 > _f) then {_e3=_f; if(_f<500)then{for [{_wp = Count Waypoints _d},{_wp>=0},{_wp=_wp-1}] do {deleteWaypoint[group _d,_wp]};_h flyinHeight 600;}};
			sleep 0.01
		};


// 3) a) Explosionen am Zielpunkt starten //////////////////
//    b) Einsatz abbrechen                //////////////////
////////////////////////////////////////////////////////////

	if (!_e1 AND getPos _h select 2 > 60) then // a) Explosion auslsen
		{	
			hint format["Bombenabwurf erfolgt!\n\nABWURFDATEN\nEntfernung: %1 m\nGeschwindigkeit: %2 km/h\nRichtgung: %3 Grad\nHoehe: %4 m",floor(_h distance _z),floor(speed _h),floor(getDir _h),floor(getPos _h select 2)];
			//---> Nur fr Testzwecke: hint format["Bomber Entfernung zum Ziel: %1\nFlugrichtung: %2 Grad\nBodenabstand beim Flug: %3\n\nZielort-Seehoehe: %4\nFlieger-Seehoehe: %5\n\nAbstand Ziel zu Flugzeug\nX: %6    Y: %7\n\nVerbleibende Zeit: %7 sek",floor(_h distance _z),floor(getDir _h),floor(getPos _h select 2),floor _a, floor(getPosASL _h select 2),floor abs((getpos _z select 0)-(getpos _h select 0)),floor abs((getpos _z select 1)-(getpos _h select 1)),floor (_t-time)];
			_h flyinHeight 600;
			_h setspeedMode "NORMAL";
			sleep 3;
			_this execVM "AirHQ\Explosionen.sqf";
			player removeAction ViennaAirMarkerAktion;
		}
	else // b) Einsatz abbrechen
		{
			hint "Bombenabwurf fehlgeschlagen! Einsatz abgebrochen!"
		};

//Pilot alle Wegpunkte lschen		
	for [{_wp = Count Waypoints _d},{_wp>=0},{_wp=_wp-1}] do {deleteWaypoint[group _d,_wp]};

//neuen Airstrike zulassen
	sleep 30;
	ViennasAirstrikeAktiv = false;
	player groupChat "**** Kampfflugzeug zum neuerlicher Airstrike einsatzbereit! ****";

// 4) Objekte lschen //////////////////////////////////////
////////////////////////////////////////////////////////////
	_t = time + 80;
	waitUntil {_h distance _z > 2000 OR time > _t};
	deleteVehicle _d;
	deleteVehicle _h;
	deleteVehicle _z
