/// Kartenausschnitte fr Airstrike /// Vienna 02.08.2008
///
/// Am Ende der description.ext die Zeile
///   #include "AirHQ\AirMap.hpp"
/// einfgen, fr das Einbinden ins Programm!


///////////////////////////////////////////////////////////////////////////////////////////


// RscMapControl ////////////////////////////////////////////
class RscMapControl_Air //Neue Version aus Warfare 31.05.2008
	{
		type = 101;
		idc  = 515;

		style = 48;
		font = "Bitstream";
		sizeEx = 0.025;
	
		soundClick[] = {"ui\ui_ok",0.2,1};
		soundEnter[] = {"ui\ui_over",0.2,1};
		soundEscape[] = {"ui\ui_cc",0.2,1};
		soundPush[] = {, 0.2, 1};
		default = false;

		colorBackground[] = {0.8,0.8,0.8,1};
		colorText[] = {0, 0, 0, 1};

		colorSea[] = {0.56, 0.8, 0.98, 0.5};
		colorForest[] = {0.6, 0.8, 0.2, 0.5};
		colorRocks[] = {0.5, 0.5, 0.5, 0.5};
		colorCountlines[] = {0.65, 0.45, 0.27, 0.5};
		colorMainCountlines[] = {0.65, 0.45, 0.27, 1};
		colorCountlinesWater[] = {0, 0.53, 1, 0.5};
		colorMainCountlinesWater[] = {0, 0.53, 1, 1};
		colorForestBorder[] = {0.4, 0.8, 0, 1};
		colorRocksBorder[] = {0.5, 0.5, 0.5, 1};
		colorPowerLines[] = {0, 0, 0, 1};
		colorNames[] = {0, 0, 0, 1};
		colorInactive[] = {1, 1, 1, 0.5};
		colorLevels[] = {0, 0, 0, 1};
		fontLabel = "TahomaB";
		sizeExLabel = 0.04;
		fontGrid = "TahomaB";
		sizeExGrid = 0.04;
		fontUnits = "TahomaB";
		sizeExUnits = 0.04;
		fontNames = "TahomaB";
		sizeExNames = 0.04;
		fontInfo = "TahomaB";
		sizeExInfo = 0.04;
		fontLevel = "TahomaB";
		sizeExLevel = 0.04;
		text = "#(argb,8,8,3)color(1,1,1,1)";
		stickX[] = {0.2, {"Gamma", 1, 1.5}};
		stickY[] = {0.2, {"Gamma", 1, 1.5}};
		ptsPerSquareSea = 6;
		ptsPerSquareTxt = 8;
		ptsPerSquareCLn = 8;
		ptsPerSquareExp = 8;
		ptsPerSquareCost = 8;
		ptsPerSquareFor = "4.0f";
		ptsPerSquareForEdge = "10.0f";
		ptsPerSquareRoad = 2;
		ptsPerSquareObj = 10;
		showCountourInterval = "true";

		x = 0.0;
		y = 0.05;
		w = 1.0;
		h = 0.8;

		onMouseMoving = "mouseX = (_this Select 1);mouseY = (_this Select 2)";
		onMouseButtonDown = "mouseButtonDown = _this Select 1";
		onMouseButtonUp = "mouseButtonUp = _this Select 1";

/*
		class Legend
		{
			x = 0.7;
			y = 0.65;
			w = 0.25;
			h = 0.09;
			font = "TahomaB";
			sizeEx = 0.04;
			colorBackground[] = {1, 1, 1, 1};
			color[] = {0, 0, 0, 1};
		};
*/		
		class Bunker
		{
			icon = "\ca\ui\data\map_bunker_ca.paa";
			color[] = {0, 0, 1, 1};
			size = 14;
			importance = 1.5 * 14 * 0.05;
			coefMin = 0.25;
			coefMax = 4;
		};
		
		class Bush
		{
			icon = "\ca\ui\data\map_bush_ca.paa";
			color[] = {0.55, 0.64, 0.43, 1};
			size = 14;
			importance = 0.2 * 14 * 0.05;
			coefMin = 0.25;
			coefMax = 4;
		};
		
		class BusStop
		{
			icon = "\ca\ui\data\map_busstop_ca.paa";
			color[] = {0, 0, 1, 1};
			size = 10;
			importance = 1 * 10 * 0.05;
			coefMin = 0.25;
			coefMax = 4;
		};
		
		class Command
		{
			icon = "#(argb,8,8,3)color(1,1,1,1)";
			color[] = {0, 0.9, 0, 1};
			size = 18;
			importance = 1;
			coefMin = 1;
			coefMax = 1;
		};
		
		class Cross
		{
			icon = "\ca\ui\data\map_cross_ca.paa";
			color[] = {0, 0, 1, 1};
			size = 16;
			importance = 0.7 * 16 * 0.05;
			coefMin = 0.25;
			coefMax = 4;
		};
		
		class Fortress
		{
			icon = "\ca\ui\data\map_bunker_ca.paa";
			color[] = {0, 0, 1, 1};
			size = 16;
			importance = 2 * 16 * 0.05;
			coefMin = 0.25;
			coefMax = 4;
		};
		
		class Fuelstation
		{
			icon = "#(argb,8,8,3)color(0,0,0,1)";
			color[] = {0, 0, 0, 1};
			size = 16;
			importance = 2 * 16 * 0.05;
			coefMin = 0.75;
			coefMax = 4;
		};
		
		class Fountain
		{
			icon = "\ca\ui\data\map_fountain_ca.paa";
			color[] = {0, 0.35, 0.7, 1};
			size = 12;
			importance = 1 * 12 * 0.05;
			coefMin = 0.25;
			coefMax = 4;
		};
		
		class Hospital
		{
			icon = "\ca\ui\data\map_hospital_ca.paa";
			color[] = {0.78, 0, 0.05, 1};
			size = 16;
			importance = 2 * 16 * 0.05;
			coefMin = 0.5;
			coefMax = 4;
		};
		
		class Chapel
		{
			icon = "\ca\ui\data\map_chapel_ca.paa";
			color[] = {0, 0, 1, 1};
			size = 16;
			importance = 1 * 16 * 0.05;
			coefMin = 0.9;
			coefMax = 4;
		};
		
		class Church
		{
			icon = "\ca\ui\data\map_church_ca.paa";
			color[] = {0, 0, 1, 1};
			size = 16;
			importance = 2 * 16 * 0.05;
			coefMin = 0.9;
			coefMax = 4;
		};
		
		class Lighthouse
		{
			icon = "\ca\ui\data\map_lighthouse_ca.paa";
			color[] = {0.78, 0, 0.05, 1};
			size = 20;
			importance = 3 * 16 * 0.05;
			coefMin = 0.9;
			coefMax = 4;
		};
		
		class Quay
		{
			icon = "\ca\ui\data\map_quay_ca.paa";
			color[] = {0, 0, 1, 1};
			size = 16;
			importance = 2 * 16 * 0.05;
			coefMin = 0.5;
			coefMax = 4;
		};
		
		class Rock
		{
			icon = "\ca\ui\data\map_rock_ca.paa";
			color[] = {0, 0, 1, 1};
			size = 12;
			importance = 0.5 * 12 * 0.05;
			coefMin = 0.25;
			coefMax = 4;
		};
		
		class Ruin
		{
			icon = "\ca\ui\data\map_ruin_ca.paa";
			color[] = {0.78, 0, 0.05, 1};
			size = 16;
			importance = 1.2 * 16 * 0.05;
			coefMin = 1;
			coefMax = 4;
		};
		
		class SmallTree
		{
			icon = "\ca\ui\data\map_smalltree_ca.paa";
			color[] = {0.55, 0.64, 0.43, 1};
			size = 12;
			importance = 0.6 * 12 * 0.05;
			coefMin = 0.25;
			coefMax = 4;
		};
		
		class Stack
		{
			icon = "\ca\ui\data\map_stack_ca.paa";
			color[] = {0, 0, 1, 1};
			size = 20;
			importance = 2 * 16 * 0.05;
			coefMin = 0.9;
			coefMax = 4;
		};
		
		class Tree
		{
			icon = "\ca\ui\data\map_tree_ca.paa";
			color[] = {0.55, 0.64, 0.43, 1};
			size = 12;
			importance = 0.9 * 16 * 0.05;
			coefMin = 0.25;
			coefMax = 4;
		};
		
		class Tourism {
			icon = "\ca\ui\data\map_tourism_ca.paa";
			color[] = {0.78, 0, 0.05, 1};
			size = 16;
			importance = 1 * 16 * 0.05;
			coefMin = 0.7;
			coefMax = 4;
		};

		class Transmitter
		{
			icon = "\ca\ui\data\map_transmitter_ca.paa";
			color[] = {0, 0, 1, 1};
			size = 20;
			importance = 2 * 16 * 0.05;
			coefMin = 0.9;
			coefMax = 4;
		};
		
		class ViewTower
		{
			icon = "\ca\ui\data\map_viewtower_ca.paa";
			color[] = {0, 0, 1, 1};
			size = 16;
			importance = 2.5 * 16 * 0.05;
			coefMin = 0.5;
			coefMax = 4;
		};
		
		class Watertower
		{
			icon = "\ca\ui\data\map_watertower_ca.paa";
			color[] = {0, 0.35, 0.7, 1};
			size = 32;
			importance = 1.2 * 16 * 0.05;
			coefMin = 0.9;
			coefMax = 4;
		};
		
		class Waypoint
		{
			icon = "\ca\ui\data\map_waypoint_ca.paa";
			color[] = {0, 0, 1, 1};
			size = 14;
			importance = 2.5 * 16 * 0.05;
			coefMin = 0.5;
			coefMax = 4;
		};
		
		class WaypointCompleted
		{
			icon = "\ca\ui\data\map_waypoint_completed_ca.paa";
			color[] = {0, 0, 1, 1};
			size = 14;
			importance = 2.5 * 16 * 0.05;
			coefMin = 0.5;
			coefMax = 4;
		};
		class ActiveMarker
		{
			icon = "";
			color[] = {0, 0, 1, 1};
			size = 14;
			importance = 2.5 * 16 * 0.05;
			coefMin = 0.5;
			coefMax = 4;
		};
	};
// RscMapControl  Ende //////////////////////////////////////



//Position und Gre der Air-Karte 1
	#define Air1_X3  0.15              //Karte Abstand vom linken Bildschirmrand
	#define Air1_Y3  0.03              //Karte Abstand vom oberen Bildschirmrand
	#define Air1_W3  0.70              //Karte Breite
	#define Air1_H3  0.90              //Karte Hhe
//Sonstiges
	#define Air1_R3  0.005             //Rahmenbreite
	#define Air1_R3_Color {0,0.5,1,.9} //Rahmenfarbe

class KartenRahmen_Air1
 {idc=-1; type= 0; style=0; colorBackground[]=Air1_R3_Color; colorText[]={0, 0, 0, 1};font="TahomaB";sizeEx=0.023;h=0.02;};
  
class AirKarte_1
{
	movingEnable = true;
	idd = 4709;
	onLoad = "_this execVM ""AirHQ\AirstrikeMapMove.sqf""";
	controlsBackground[] = { };
	objects[] = { };
	controls[] = {Karte_Air,RandLinks,RandRechts,RandOben,RandUnten};

	class RandLinks : KartenRahmen_Air1
		{x=Air1_X3; y=Air1_Y3; w=Air1_R3; h=Air1_H3; text=;};
	class RandRechts : KartenRahmen_Air1
		{x=Air1_X3+Air1_W3-Air1_R3; y=Air1_Y3; w=Air1_R3; h=Air1_H3; text=;};
	class RandOben : KartenRahmen_Air1
		{x=Air1_X3; y=Air1_Y3; w=Air1_W3; h=Air1_R3; text=;};
	class RandUnten : KartenRahmen_Air1
		{
			style=2;colorText[]={1,1,1,1};x=Air1_X3; y=Air1_Y3+Air1_H3-Air1_R3-0.003; w=Air1_W3; h=Air1_R3+0.03;
			text="Klicke auf der Karte den Zielpunkt zum Luftangriff an!";
		};
	
	class Karte_Air : RscMapControl_Air
	{
		idc = 4710;
		x = Air1_X3+Air1_R3;
		y = Air1_Y3+Air1_R3;
		w = Air1_W3-Air1_R3*2;
		h = Air1_H3-Air1_R3*2;
		default = true;
	};
};


/////////////////////////////////////////////////////////////


//Position und Gre der Air-Karte 2
	#define Air2_X3  0.30              //Karte Abstand vom linken Bildschirmrand
	#define Air2_Y3  0.03              //Karte Abstand vom oberen Bildschirmrand
	#define Air2_W3  0.69              //Karte Breite
	#define Air2_H3  0.92              //Karte Hhe
//Sonstiges
	#define Air2_R3  0.005             //Rahmenbreite
	#define Air2_R3_Color {0,0.5,1,.9} //Rahmenfarbe

class KartenRahmen_Air2
 {idc=-1; type= 0; style=0; colorBackground[]=Air2_R3_Color; colorText[]={0, 0, 0, 1};font="TahomaB";sizeEx=0.023;h=0.02;};
  
class AirKarte_2
{
	movingEnable = true;
	idd = 4711;
	controlsBackground[] = { };
	objects[] = { };
	controls[] = {Karte_Air,RandLinks,RandRechts,RandOben,RandUnten};

	class RandLinks : KartenRahmen_Air2
		{x=Air2_X3; y=Air2_Y3; w=Air2_R3; h=Air2_H3; text=;};
	class RandRechts : KartenRahmen_Air2
		{x=Air2_X3+Air2_W3-Air2_R3; y=Air2_Y3; w=Air2_R3; h=Air2_H3; text=;};
	class RandOben : KartenRahmen_Air2
		{x=Air2_X3; y=Air2_Y3; w=Air2_W3; h=Air2_R3; text=;};
	class RandUnten : KartenRahmen_Air2
		{
			style=2;colorText[]={1,1,1,1};x=Air2_X3; y=Air2_Y3+Air2_H3-Air2_R3-0.003; w=Air2_W3; h=Air2_R3+0.03;
			text="Beenden mit ESC";
		};
	
	class Karte_Air : RscMapControl_Air
	{
		idc = 4712;
		x = Air2_X3+Air2_R3;
		y = Air2_Y3+Air2_R3;
		w = Air2_W3-Air2_R3*2;
		h = Air2_H3-Air2_R3*2;
		default = true;
	};
};


/// Ende ////////////////////////////////////////////////////